import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";

/* eslint-disable no-unused-expressions */
import { Typography } from "@mui/material";
import React from "react";
import NormalInput from "../Components/AnnoatationNormalInput";
import AnnotationInput from "../Components/AnnotationInput";
import LocalStorage from "../Components/LocalStorage";
import { errorSpan, fielderror, ShowCount, trimRule } from "../Components/ValidationCheck";
var Getrules = LocalStorage.get_task_rules() || {};

function FormOCR(_ref) {
  var index = _ref.index,
      formData = _ref.formData,
      setFormData = _ref.setFormData,
      item = _ref.item;

  var _ref2 = item || {},
      invalid = _ref2.invalid,
      description_labelling = _ref2.description_labelling,
      image_urls_labelling = _ref2.image_urls_labelling,
      title = _ref2.title,
      default_type = _ref2.default_type,
      display_label = _ref2.display_label,
      content = _ref2.content,
      input_type = _ref2.input_type,
      value = _ref2.value,
      other_value = _ref2.other_value,
      mandatory = _ref2.mandatory,
      history_hide = _ref2.history_hide,
      editable_data = _ref2.editable_data;

  var labelStyle = {
    width: "90%",
    overflow: "hidden",
    wordBreak: "break-all",
    display: "inline-block"
  };

  var _ref3 = Getrules || {},
      rules = _ref3.rules,
      editable_fields = _ref3.editable_fields,
      save_mandatory_fields = _ref3.save_mandatory_fields,
      find_and_replace = _ref3.find_and_replace,
      hide_physical_link = _ref3.hide_physical_link,
      dropdown_data = _ref3.dropdown_data,
      symbol_find_replace = _ref3.symbol_find_replace;

  var rule_arr = rules === null || rules === void 0 ? void 0 : rules[title];

  var onActionFieldError = function onActionFieldError(title, border) {
    return fielderror(rule_arr, content, formData, "form", false, title, border);
  };

  var fieldValidationMessage = function fieldValidationMessage(border) {
    var _ref4 = onActionFieldError() || {},
        keys = _ref4.keys,
        messageShow = _ref4.messageShow;

    var errorMess = border ? messageShow === null || messageShow === void 0 ? void 0 : messageShow.length : errorSpan(messageShow);
    return keys !== "roundoff" ? keys !== "concat" ? onActionFieldError() : errorMess : errorMess;
  };

  var handleOnChangeFields = function handleOnChangeFields(value) {
    var _onActionFieldError = onActionFieldError(),
        keys = _onActionFieldError.keys,
        values = _onActionFieldError.values;

    var data = _toConsumableArray(formData);

    if (keys === "concat") {
      data[index].content = values;
    } else {
      data[index].content = value;
    }

    setFormData(data);
  };

  var handleRulesApplyOnFoucsBlur = function handleRulesApplyOnFoucsBlur() {
    var _ref5 = onActionFieldError() || {},
        keys = _ref5.keys,
        values = _ref5.values;

    console.log(onActionFieldError());
    keys === "roundoff" ? handleOnChangeFields(values, false) : null;
    keys === "concat" ? handleOnChangeFields(values, false) : null;
    var find_replace_arr = (find_and_replace === null || find_and_replace === void 0 ? void 0 : find_and_replace[title]) || [];
    var string = values || content;

    if (keys === "concat") {
      string = values;
    }

    try {
      if (string) {
        for (var i = 0; i < (find_replace_arr === null || find_replace_arr === void 0 ? void 0 : find_replace_arr.length); i++) {
          var _string;

          string = (_string = string) === null || _string === void 0 ? void 0 : _string.replaceAll(find_replace_arr[i].search, find_replace_arr[i].replace);
        }

        var symbol_find_replace_rule = (symbol_find_replace === null || symbol_find_replace === void 0 ? void 0 : symbol_find_replace[title]) || {};

        var _ref6 = symbol_find_replace_rule || {},
            find_replace = _ref6.find_replace,
            symbol = _ref6.symbol;

        var symbol_rule_string = "";

        if (find_replace !== null && find_replace !== void 0 && find_replace.length && symbol_rule_string) {
          string = symbol_rule_string;
        }

        string = trimRule({
          rules_arr: rule_arr,
          content: string
        });
        handleOnChangeFields(string);
      }
    } catch (err) {
      console.log("handle_symbol_find_replace break", err);
    }
  };

  return input_type === "label" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("p", {
    className: "font-MontSemiBold task_formlabel"
  }, display_label), /*#__PURE__*/React.createElement(Typography, null, content)) : input_type === "textArea" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(AnnotationInput, {
    isRequired: mandatory === "mandatory",
    rows: 3,
    title: display_label,
    id: display_label,
    value: content,
    fullWidth: true,
    onChange: function onChange(e) {
      handleOnChangeFields(e.target.value);
    },
    focused: true,
    onblur: function onblur() {
      return handleRulesApplyOnFoucsBlur();
    }
  }), ShowCount({
    rules_arr: rules === null || rules === void 0 ? void 0 : rules[display_label]
  }) && /*#__PURE__*/React.createElement("span", {
    style: {
      fontSize: "0.7rem"
    },
    className: "text-green-600 flex justify-start"
  }, String(content).length), fieldValidationMessage()) : input_type === "input" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(NormalInput, {
    onFocus: function onFocus() {
      return handleRulesApplyOnFoucsBlur();
    },
    labelClass: "task_formlabel",
    title: display_label,
    value: content,
    onChange: function onChange(e) {
      handleOnChangeFields(e.target.value);
    },
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    onblur: function onblur() {
      handleRulesApplyOnFoucsBlur();
    },
    count: false,
    isTooltip: true // readOnly={valueExist ? readOnly : false}

  }), ShowCount({
    rules_arr: rules === null || rules === void 0 ? void 0 : rules[display_label]
  }) && /*#__PURE__*/React.createElement("span", {
    style: {
      fontSize: "0.7rem"
    },
    className: "text-green-600 flex justify-start"
  }, String(content).length), fieldValidationMessage()) : null;
}

export default FormOCR;